-- QuickCheck code for Document
--
-- ICFP 2001 programming contest
-- Tom Moertel <tom-icfp2001@moertel.com>

module Document_qc where
import Document
import Monad
import QuickCheck

instance Arbitrary Char where
    arbitrary = oneof (map return (['A'..'Z'] ++ "    "))
    coarbitrary = variant . fromEnum

instance Arbitrary Document where
    arbitrary = liftM Document arbitrary
    coarbitrary = error "this coarbitrary should never be used"

instance Arbitrary DocPart where
    arbitrary = sized arbDP
    coarbitrary = error "this coarbitrary should never be used"

arbDP 0 = liftM DText arbitrary
arbDP n = frequency (map partGen (  [ DB, DEM, DI, DPL, DS, DTT, DU ]
                                    ++ map DSize [ 0 .. 9 ]
                                    ++ map DColor [ minBound .. White ]
                                 )
                     ++ [(15, liftM DText arbitrary) ]
                    )
          where partGen ctor = (1, resize (n `div` 2) $ liftM ctor arbitrary)

-- instance Arbitrary Color where
-- 	   arbitrary = oneof (map return [minBound .. White])
-- 	   coarbitrary = error "this coarbitrary should never be used"

