-- Main
--
-- ICFP 2001 programming contest
-- Tom Moertel <tom-icfp2001@moertel.com>

-- DO NOT WRITE ANYTHING TO STDOUT THAT ISN'T OUTPUT!

module Main where

import System
import IO
import Directory

import Document
import Parse
import NaiveOptimization


main :: IO ()
main =
    do args <- getArgs
       let [timeLimit, resultsFile] = args
--            case args of
--                x:y:_   -> let v :: Int
--                               v = read x
--                               in (v, y)
--                _       -> error "Usage: main time-limit work-directory"
       pnam <- getProgName
       input <- readFile resultsFile
       let doc = case parseS input of
                 Left  e -> error (show e)
                 Right d -> d
--     logMsg "parsing complete"
       let doc' = naiveOptimizer doc
--     logMsg "optimization round 1 complete"
       writeDocResults resultsFile doc'


-- write results to dir/out in an atomic operation (unless we
-- completely replace the existing dir/out file, we don't change
-- it at all; and when we do change it, the change appears to
-- have occurred instantaneously)

writeResults :: FilePath -> String -> IO ()
writeResults resultsFile results =
    let tempFile = resultsFile ++ ".tmp" in
    do -- logMsg ("writing results file (" ++ show (length results) ++ " bytes)")
       writeFile tempFile results
       renameFile tempFile resultsFile
--       logMsg "  -> done"

writeDocResults :: FilePath -> Document -> IO ()
writeDocResults resultsFile doc = writeResults resultsFile (showDoc doc)

logMsg :: String -> IO ()
logMsg s = hPutStrLn stderr s
