-- QuickCheck code for NaiveOptimizer
--
-- ICFP 2001 programming contest
-- Tom Moertel <tom-icfp2001@moertel.com>

module NaiveOptimization_qc where

import QuickCheck

import NaiveOptimization
import Document
import Document_qc
import Meaning
import Parse

prop_NaiveOptimizerPreservesSemantics :: Document -> Property
prop_NaiveOptimizerPreservesSemantics doc =
    lsdoc /= lsdoc' ==>
--    classify (lsdoc' < lsdoc) "shorter!" $
    collect (buckets - (buckets * lsdoc' `div` lsdoc) ) $
    docMeaning doc == docMeaning doc' -- assert that meaning is unchanged
    where doc'  = naiveOptimizer doc
          sdoc  = show doc
          sdoc' = show doc'
          lsdoc = length sdoc
          lsdoc'= length sdoc'
          buckets = 10
